#define RGBTXTPATH "/usr/lib/X11/rgb.txt"
#define BROWSERPATH "Mosaic  "
#define INSTALLDIR "/opt/XColorSel/bin"
/*  You shouldn't need to change any of the defines here... They are created
 *  by the Makefile.  Edit that instead.
 ******************************************************************************/
/******************************************************************************
 * The XJNSlib X library (XJNSlib.c and XJNSlib.h) are Copyright (c) 1995 by  *
 * Jon N. Steiger, and is licensed for non-commercial use *only*.  If you     *
 * use any of this code in your own programs, please give credit where credit *
 * is due.  Thanks.  xcolorsel.jon, xcolorsel.c also (C)1995  -Jon-           *
 ******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <X11/Xlib.h> 
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <sys/types.h>
#include <sys/time.h>
#include "XJNSlib.h"
#include "BITMAPS/cow1.xbm"
#include "BITMAPS/cow1mask.xbm"
#include "BITMAPS/cow3.xbm"
#include "BITMAPS/cow3mask.xbm"
#include "BITMAPS/cow5.xbm"
#include "BITMAPS/cow5mask.xbm"
#include "BITMAPS/cow7.xbm"
#include "BITMAPS/cow7mask.xbm"
#include "BITMAPS/cow2.xbm"
#include "BITMAPS/cow2mask.xbm"
#include "BITMAPS/cow4.xbm"
#include "BITMAPS/cow4mask.xbm"
#include "BITMAPS/cow6.xbm"
#include "BITMAPS/cow6mask.xbm"
#include "BITMAPS/cow8.xbm"
#include "BITMAPS/cow8mask.xbm"
#include "BITMAPS/nocow.xbm"
#include "BITMAPS/pointer.xbm"


#define MAXWIDTH 1150
#define MAXHEIGHT 920 
#define WIDTH 950
#define HEIGHT 800 
#define ABOUTWIDTH 500
#define ABOUTHEIGHT 500 
#define EDITORWIDTH 700
#define EDITORHEIGHT 500 
#define CWINWIDTH 330
#define CWINHEIGHT 50 
#define NUMPLANES 5
#define FONT "-*-charter-*-*-*--50-*-*-*-*-*-*-*"
#define FONT2 "-*-courier-bold-r-*-*-20-*-*-*-*-*-*-*"
#define NUMCURSORS 8  /* number of frames in the spinning cursor */
#define CHUNK 10   /* malloc / realloc chunk size */


int LastIndex;
int EndOfArray;
int TheEditorColor, triangle, customred = 0, StartColor,
customgreen = 0, 
customblue = 0;
Cursor TheCurrentCursor;
struct RGBtxt {
	char *ColorName;
	unsigned char Red;
	unsigned char Green;
	unsigned char Blue;
};
struct RGBtxt *RGBArray;

void DrawAllTriangles(Display *TheDisplay, Window TheScrollWindow[], GC TheGC, 
int x, int h);
void SetColors(Display *TheDisplay, Colormap colormap,  struct RGBtxt *RGBArray, unsigned long StartColor);
int LoadArray(Display *TheDisplay, Window TheCountWindow, GC TheGC, 
Window TheWindow, Cursor *TheCursorArray);
void DrawNewStuff(Display *TheDisplay, Window TheWindow, int X, int Y, 
int Width, int Height);
int XtoY(int x, int y);

enum { Black, LightBlack, White, WindowGrey, SubWindowGrey, SuperWindowGrey,  DarkBevel, LightBevel, Red, Green, Blue, Yellow, Purple,  CustomColor };
main()
{
	Atom wm_delete_window;
	int atomstatus;
	Atom wm_protocols;


	fd_set FDSet;
	int ConnectionNum;  /* select stuff */
	struct timeval timeout = {
		0, 100000		}; /* select timeout (seconds, milli) */

	int colorcountp = 0, colorcount = 0, cursorpos = 0, FirstTime = 0,  percentage = 0;
	int XPos, YPos, i, cowcursorbool = 1;
	int TheScrollWindowValue[10];
	char *buffer = " - XColorSel - ";
	char *buffer2 = "Copyright (c) 1995 Jon N. Steiger";
	char *buffer3 = "Percentage of colors viewed so far:";
	char *buffer4 = "Colors loaded:";
	char *button0 = "Quit";
	char *button1 = "Reload";
	char *button2 = "Color";
	char *button2a = "Editor";
	char *button3 = "Help";
	char *button4 = "About";
	char *aboutbuffer1 = "About XColorSel 1.0:";


	/* window */
	Display *TheDisplay;
	int TheScreen;
	XSetWindowAttributes TheWindowAttributes;
	unsigned long TheWindowMask;
	XSizeHints TheSizeHints;
	Window TheWindow, TheRootWindow, TheChildWindow[10], TheRGBWindow[10], TheScrollWindow[10], TheCountWindow[2], TheButtonWindow[6],  TheAboutWindow,
	    TheAboutOKWindow, TheAboutMailWindow, TheEditorWindow, TheEditorOKWindow, TheEditorRGBWindow, TheEditorColorWindow;

	/* colormap */

	XVisualInfo xvtemplate, *visary;
	Visual *visual;
	Colormap colormap;
	XColor color, BlackColorStruct, WhiteColorStruct;
	int depth, numvis, num, status, x, y;
	double R,G,B;


	/* events */
	XEvent TheEvent;

	/* drawing */
	GC TheGC;
	XGCValues xgcvals;

	/* text */
	XFontStruct *TheFont, *TheFont2;

	/* cursors */
	Cursor TheCursorArray[NUMCURSORS], DefaultCursor;
	Pixmap ThePixmapArray[NUMCURSORS*2], NoCow, Pointer;

	long longx;

	TheDisplay = XOpenDisplay(NULL);
	if (TheDisplay == NULL) {
		printf("ERROR: Unable to open connection to %s\n", XDisplayName(NULL));
		exit(10);
	}
	ConnectionNum = ConnectionNumber(TheDisplay);

	TheScreen = DefaultScreen(TheDisplay);

	TheRootWindow = RootWindow(TheDisplay, TheScreen);

	wm_protocols = XInternAtom (TheDisplay, "WM_PROTOCOLS", False);
	wm_delete_window = XInternAtom (TheDisplay, "WM_DELETE_WINDOW", False);

	/*
 * find a pseudocolor visual with at least NUMPLANES planes of color (64)
 */

	xvtemplate.class = PseudoColor;
	xvtemplate.screen = TheScreen;
	visary = XGetVisualInfo(TheDisplay, VisualClassMask | VisualScreenMask, &xvtemplate, &numvis);
	num = 0;
	if (numvis > 0) {
		while(num < numvis) {
			if (visary->depth >= NUMPLANES) break;
			num++;
		}
		if (num < numvis) {
			visual = visary[num].visual;
			depth = visary[num].depth;
                        StartColor = XtoY(2, visary->depth) - 11;
		}
		XFree(visary);
	}
	if (num >= numvis) {
		fprintf(stderr, "ERROR: Couldn't get %d Pseudo Color visual!\n", XtoY(2, NUMPLANES));
		exit(1);
	}

	colormap = XCreateColormap(TheDisplay, TheRootWindow, visual, AllocAll);

	color.flags = DoRed | DoGreen | DoBlue;


	color.pixel = Black;
	color.red = 0;
	color.green = 0;
	color.blue = 0;
	XStoreColor(TheDisplay, colormap, &color);

	BlackColorStruct = color;   /* for cursors */

	color.pixel = LightBlack;
	color.red = ColorAdjust(70);
	color.green = ColorAdjust(70);
	color.blue = ColorAdjust(70);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = White;
	color.red = 65535;
	color.green = 65535;
	color.blue = 65535;
	XStoreColor(TheDisplay, colormap, &color);

	WhiteColorStruct = color;   /* for cursors */

	color.pixel = WindowGrey;
	color.red = ColorAdjust(191);
	color.green = ColorAdjust(191);
	color.blue = ColorAdjust(191);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = SubWindowGrey;
	color.red = ColorAdjust(156);
	color.green = ColorAdjust(156);
	color.blue = ColorAdjust(156);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = SuperWindowGrey;
	color.red = ColorAdjust(175);
	color.green = ColorAdjust(175);
	color.blue = ColorAdjust(175);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = DarkBevel;
	color.red = ColorAdjust(86);
	color.green = ColorAdjust(86);
	color.blue = ColorAdjust(86);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = LightBevel;
	color.red = ColorAdjust(231);
	color.green = ColorAdjust(231);
	color.blue = ColorAdjust(231);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = Red;
	color.red = ColorAdjust(255);
	color.green = ColorAdjust(0);
	color.blue = ColorAdjust(0);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = Green;
	color.red = ColorAdjust(0);
	color.green = ColorAdjust(255);
	color.blue = ColorAdjust(0);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = Blue;
	color.red = ColorAdjust(0);
	color.green = ColorAdjust(0);
	color.blue = ColorAdjust(255);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = Yellow;
	color.red = ColorAdjust(255);
	color.green = ColorAdjust(255);
	color.blue = ColorAdjust(0);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = Purple;
	color.red = ColorAdjust(164);
	color.green = ColorAdjust(0);
	color.blue = ColorAdjust(173);
	XStoreColor(TheDisplay, colormap, &color);

	color.pixel = CustomColor;
	color.red = ColorAdjust(customred);
	color.green = ColorAdjust(customgreen);
	color.blue = ColorAdjust(customblue);
	XStoreColor(TheDisplay, colormap, &color);


	/*
 *  set start colors for childwindows
 */

	for (x = StartColor; x < StartColor + 10; x++){
		color.pixel = x;
		color.red = ColorAdjust(156);
		color.green = ColorAdjust(156);
		color.blue = ColorAdjust(156);
		XStoreColor(TheDisplay, colormap, &color);
	}




	/*
 *  Loading in pixmaps and stuff for cursors
 */
	Pointer = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  pointer_bits, pointer_width,  pointer_height, 1, 0, 1);

	NoCow = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  nocow_bits, nocow_width,  nocow_height, 1, 0, 1);

	ThePixmapArray[0] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow1_bits, cow1_width,  cow1_height, 1, 0, 1);
	ThePixmapArray[1] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow1mask_bits, cow1mask_width,  cow1mask_height, 1, 0, 1);
	ThePixmapArray[2] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow2_bits, cow2_width,  cow2_height, 1, 0, 1);
	ThePixmapArray[3] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow2mask_bits, cow2mask_width,  cow2mask_height, 1, 0, 1);
	ThePixmapArray[4] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow3_bits, cow3_width,  cow3_height, 1, 0, 1);
	ThePixmapArray[5] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow3mask_bits, cow3mask_width,  cow3mask_height, 1, 0, 1);
	ThePixmapArray[6] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow4_bits, cow4_width,  cow4_height, 1, 0, 1);
	ThePixmapArray[7] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow4mask_bits, cow4mask_width,  cow4mask_height, 1, 0, 1);
	ThePixmapArray[8] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow5_bits, cow5_width,  cow5_height, 1, 0, 1);
	ThePixmapArray[9] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow5mask_bits, cow5mask_width,  cow5mask_height, 1, 0, 1);
	ThePixmapArray[10] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow6_bits, cow6_width,  cow6_height, 1, 0, 1);
	ThePixmapArray[11] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow6mask_bits, cow6mask_width,  cow6mask_height, 1, 0, 1);
	ThePixmapArray[12] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow7_bits, cow7_width,  cow7_height, 1, 0, 1);
	ThePixmapArray[13] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow7mask_bits, cow7mask_width,  cow7mask_height, 1, 0, 1);
	ThePixmapArray[14] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow8_bits, cow8_width,  cow8_height, 1, 0, 1);
	ThePixmapArray[15] = XCreatePixmapFromBitmapData(TheDisplay, TheRootWindow,  cow8mask_bits, cow8mask_width,  cow8mask_height, 1, 0, 1);
	for (x = 0; x < NUMCURSORS; x ++)
		TheCursorArray[x] = XCreatePixmapCursor(TheDisplay, ThePixmapArray[x*2], ThePixmapArray[x*2+1], /* mask */
		&BlackColorStruct, &WhiteColorStruct, 0, 0);
	DefaultCursor = XCreateFontCursor(TheDisplay, 132);
	TheCurrentCursor = TheCursorArray[0];


	TheWindowAttributes.border_pixel = Black;
	TheWindowAttributes.background_pixel = WindowGrey;
	TheWindowAttributes.colormap = colormap;
	TheWindowAttributes.event_mask = ExposureMask;
	TheWindowMask = CWBackPixel | CWBorderPixel | CWColormap | CWEventMask;
	/* flag (mask) structure */
	/* tells which fields are set */


	/*
 * first create main window
 */

	TheWindow = XCreateWindow(TheDisplay, TheRootWindow, /* geometry */
	10, 10, WIDTH, HEIGHT,  /* geometry */
	2,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	/*
 * Now create editor, help, about windows
 */


	TheAboutWindow = XCreateWindow(TheDisplay, TheRootWindow, /* geometry */
	10, 10, ABOUTWIDTH, ABOUTHEIGHT,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	TheSizeHints.min_width = TheSizeHints.max_width = ABOUTWIDTH;
	TheSizeHints.min_height = TheSizeHints.max_height = ABOUTHEIGHT;
	TheSizeHints.flags = PMaxSize | PMinSize;  /* tell which fields are set */
	XSetNormalHints(TheDisplay, TheAboutWindow, &TheSizeHints);


	TheWindowAttributes.background_pixel = SuperWindowGrey;
	TheWindowAttributes.event_mask = ExposureMask | ButtonPressMask |  ButtonReleaseMask;

	TheAboutOKWindow = XCreateWindow(TheDisplay, TheAboutWindow, /* geometry */
	ABOUTWIDTH - 220, ABOUTHEIGHT - 80,  200, 60,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	TheAboutMailWindow = XCreateWindow(TheDisplay, TheAboutWindow, /* geometry */
	20, ABOUTHEIGHT - 80,  200, 60,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	TheWindowAttributes.background_pixel = WindowGrey;


	TheEditorWindow = XCreateWindow(TheDisplay, TheRootWindow, /* geometry */
	10, 10, ABOUTWIDTH, ABOUTHEIGHT,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	TheSizeHints.min_width = TheSizeHints.max_width = EDITORWIDTH;
	TheSizeHints.min_height = TheSizeHints.max_height = EDITORHEIGHT;
	TheSizeHints.flags = PMaxSize | PMinSize;  /* tell which fields are set */
	XSetNormalHints(TheDisplay, TheEditorWindow, &TheSizeHints);

	TheWindowAttributes.background_pixel = SubWindowGrey;

	TheEditorColorWindow = XCreateWindow(TheDisplay, TheEditorWindow, /* geometry */
	12, 15, 260, 470,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	TheSizeHints.min_width = TheSizeHints.max_width = EDITORWIDTH;
	TheSizeHints.min_height = TheSizeHints.max_height = EDITORHEIGHT;
	TheSizeHints.flags = PMaxSize | PMinSize;  /* tell which fields are set */
	XSetNormalHints(TheDisplay, TheEditorWindow, &TheSizeHints);


	TheWindowAttributes.border_pixel = Black;
	TheWindowAttributes.background_pixel = SuperWindowGrey;
	TheWindowAttributes.colormap = colormap;
	TheWindowAttributes.event_mask = ExposureMask | ButtonPressMask |  ButtonReleaseMask;

	TheEditorOKWindow = XCreateWindow(TheDisplay, TheEditorWindow, /* geometry */
	EDITORWIDTH - 420, EDITORHEIGHT - 80,  200, 60,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);


	TheWindowAttributes.background_pixel = Black;

	TheEditorRGBWindow = XCreateWindow(TheDisplay, TheEditorWindow, /* geometry */
	EDITORWIDTH - 420, 15,  200, 390,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);


	atomstatus = XSetWMProtocols(TheDisplay, TheAboutWindow,  &wm_delete_window, 1);
	atomstatus = XSetWMProtocols(TheDisplay, TheEditorWindow,  &wm_delete_window, 1);

	/*
 * now create sub windows
 */

	TheWindowAttributes.background_pixel = SubWindowGrey;

	/* flag (mask) structure */
	/* tells which fields are set */

	YPos = 90 + CWINHEIGHT + 10;
	XPos = 35;

	for (x = 0; x <= 9; x++) {
		TheChildWindow[x] = XCreateWindow(TheDisplay, TheWindow, /* geometry */
		XPos, YPos, CWINWIDTH, CWINHEIGHT,  /* geometry */
		0,   /* border width */
		depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
		visual,  TheWindowMask, &TheWindowAttributes);
		TheRGBWindow[x] = XCreateWindow(TheDisplay, TheWindow, /* geometry */
		XPos + CWINWIDTH + 5, YPos, CWINWIDTH, CWINHEIGHT,  /* geometry */
		0,   /* border width */
		depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
		visual,  TheWindowMask, &TheWindowAttributes);

		TheScrollWindow[x] = XCreateWindow(TheDisplay, TheWindow, /* geometry */
		XPos + (2 * CWINWIDTH) + 31, YPos, 90, CWINHEIGHT,  /* geometry */
		0,   /* border width */
		depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
		visual,  TheWindowMask, &TheWindowAttributes);


		YPos += (10 + CWINHEIGHT);
	}  /* for */

	TheCountWindow[0] = XCreateWindow(TheDisplay, TheWindow, /* geometry */
	430 , 80, 90, CWINHEIGHT,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	TheCountWindow[1] = XCreateWindow(TheDisplay, TheWindow, /* geometry */
	700 , 80, 210, CWINHEIGHT,  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or 
                              not input/output is useable */
	visual,  TheWindowMask, &TheWindowAttributes);

	/* button windows */

	TheButtonWindow[0] =  XCreateWindow(TheDisplay, TheWindow, /* geometry */
	830 , 150, 100, (CWINHEIGHT * 2 + 10),  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or
                              not input/output is useable */
	visual, TheWindowMask, &TheWindowAttributes);

	TheButtonWindow[1] =  XCreateWindow(TheDisplay, TheWindow, /* geometry */
	830 , 270, 100, (CWINHEIGHT * 2 + 10),  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or
                              not input/output is useable */
	visual, TheWindowMask, &TheWindowAttributes);

	TheButtonWindow[2] =  XCreateWindow(TheDisplay, TheWindow, /* geometry */
	830 , 390, 100, (CWINHEIGHT * 2 + 10),  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or
                              not input/output is useable */
	visual, TheWindowMask, &TheWindowAttributes);

	TheButtonWindow[3] =  XCreateWindow(TheDisplay, TheWindow, /* geometry */
	830 , 510, 100, (CWINHEIGHT * 2 + 10),  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or
                              not input/output is useable */
	visual, TheWindowMask, &TheWindowAttributes);

	TheButtonWindow[4] =  XCreateWindow(TheDisplay, TheWindow, /* geometry */
	830 , 630, 100, (CWINHEIGHT),  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or
                              not input/output is useable */
	visual, TheWindowMask, &TheWindowAttributes);
	TheButtonWindow[5] =  XCreateWindow(TheDisplay, TheWindow, /* geometry */
	830 , 690, 100, (CWINHEIGHT),  /* geometry */
	0,   /* border width */
	depth, InputOutput, /* X flags saying wether or
                              not input/output is useable */
	visual, TheWindowMask, &TheWindowAttributes);

	TheSizeHints.min_width = TheSizeHints.max_width = WIDTH;
	TheSizeHints.min_height = TheSizeHints.max_height = HEIGHT;
	TheSizeHints.flags = PMaxSize | PMinSize;  /* tell which fields are set */

	XSetNormalHints(TheDisplay, TheWindow, &TheSizeHints);

	XSetIconName(TheDisplay, TheWindow, "XColorSel");
	XStoreName(TheDisplay, TheWindow, "XColorSel Version 1.0");
	XSetIconName(TheDisplay, TheAboutWindow, "XFS: About");
	XStoreName(TheDisplay, TheAboutWindow, "About XColorSel");
	XSetIconName(TheDisplay, TheEditorWindow, "XFS: Editor");
	XStoreName(TheDisplay, TheEditorWindow, "XColorSel Color Editor");



	TheGC = XCreateGC(TheDisplay, TheWindow, 0, NULL);
	/* text */

	TheFont = XLoadQueryFont(TheDisplay, FONT);
	TheFont2 = XLoadQueryFont(TheDisplay, FONT2);




	XMapRaised(TheDisplay, TheWindow);
	XMapSubwindows(TheDisplay, TheWindow);

	/* events */


	RGBArray = (struct RGBtxt *) malloc(10 * sizeof(struct RGBtxt));
	EndOfArray = 9;
	for (LastIndex = 0; LastIndex < 10; LastIndex++) {
		RGBArray[LastIndex].Red = 0;
		RGBArray[LastIndex].Green = 0;
		RGBArray[LastIndex].Blue = 0;
		RGBArray[LastIndex].ColorName = "-- None --";
	}
	LastIndex = 0;



	XDefineCursor(TheDisplay, TheWindow, TheCurrentCursor);
	XDefineCursor(TheDisplay, TheAboutWindow, TheCurrentCursor);
	XDefineCursor(TheDisplay, TheEditorWindow, TheCurrentCursor);

	while(1) {
		FD_ZERO(&FDSet);
		FD_SET(ConnectionNum, &FDSet);
		XFlush(TheDisplay);
		select(FD_SETSIZE, &FDSet, NULL, NULL, &timeout);
		if (FD_ISSET(ConnectionNum, &FDSet)) {
			while(XCheckMaskEvent(TheDisplay, 0xFFFFFFFFL, &TheEvent)) {
				switch(TheEvent.type) {
				case Expose:
					if ((TheAboutWindow == TheEvent.xany.window) || !FirstTime) {
						BevelWindow(TheDisplay, TheAboutWindow, TheGC, 1,  0,0, ABOUTWIDTH, ABOUTHEIGHT, 5, LightBevel, DarkBevel,
						    Black);
						BevelWindow(TheDisplay, TheAboutMailWindow, TheGC, 1,  0,0, 200, 60, 3, LightBevel, DarkBevel, Black);
						XPos = CenterWidth(TheFont2, "Mail Comments", 200);
						Draw3D(TheDisplay, TheAboutMailWindow, TheGC,   XPos, 35, "Mail Comments", Blue, White, Black);
						BevelWindow(TheDisplay, TheAboutOKWindow, TheGC, 1,  0,0, 200, 60, 2, LightBevel, DarkBevel, Black);
						XPos = CenterWidth(TheFont2, "Close", 200);
						Draw3D(TheDisplay, TheAboutOKWindow, TheGC,   XPos, 35, "Close", Blue, White, Black);
						XPos = CenterWidth(TheFont2, aboutbuffer1 , ABOUTWIDTH);
						XSetForeground(TheDisplay, TheGC, Black);
						XSetFont(TheDisplay, TheGC, TheFont2->fid);
						Draw3D(TheDisplay, TheAboutWindow, TheGC,   XPos, 30, aboutbuffer1, Blue, White, Black);
						BevelWindow(TheDisplay, TheAboutWindow, TheGC, 0,/* "hr" */
						10, 40, ABOUTWIDTH - 20, 2 , 1, LightBevel, DarkBevel, WindowGrey );
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 70, 0,  "XColorSel was written by Jon N. Steiger",
						    Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 90, 0,  "with the help of Jaek Smith in April -",
						    Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 110, 0,  "May of 1995 at the State University of",

						    Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 130, 0,  "New York College at Fredonia.  ",  Black,
						    Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 150, 0,  "XColorSel is freeware, but I retain", Black,
						    Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 170, 0,  "all copyrights on the source code and",
						    Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 190, 0,  "the XJNSlib library.  You can freely", Black,
						    Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 210, 0,  "copy, distribute, or change this", Black,
						    Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 230, 0,  "program, but please do not try to pass",
						    Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 250, 0,  "it off as your own code.  This is", Black,
						    Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 270, 0,  "illegal, a Bad Thing(tm) and it tends",
						    Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 290, 0,  "to annoy me. Anyway, enjoy the program!",
						    Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 320, 0,  "                         -Jon-   ", Black,
						    Black);
						BevelWindow(TheDisplay, TheAboutWindow, TheGC, 0,/* "hr" */
						10, 330, ABOUTWIDTH - 20, 2 , 1, LightBevel, DarkBevel, WindowGrey );
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 350, 0,  "Current address:", Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 370, 0,  "stei0302@cs.fredonia.edu", Black,  Black);
						Draw2D(TheDisplay, TheAboutWindow, TheGC,  20, 390, 0,  "http://www.cs.fredonia.edu/~stei0302/",
						    Black,  Black);
						BevelWindow(TheDisplay, TheAboutWindow, TheGC, 0,/* "hr" */
						10, 400, ABOUTWIDTH - 20, 2 , 1, LightBevel, DarkBevel, WindowGrey );
					}
					if ((TheEditorWindow == TheEvent.xany.window) || !FirstTime) {
						BevelWindow(TheDisplay, TheEditorWindow, TheGC, 1,  0,0, EDITORWIDTH - 200, EDITORHEIGHT, 5, LightBevel,
						    DarkBevel, Black);
						BevelWindow(TheDisplay, TheEditorRGBWindow, TheGC, 1,  0,0, 200, 390, 3, LightBevel, DarkBevel, Black);

						BevelWindow(TheDisplay, TheEditorOKWindow, TheGC, 1,  0,0, 200, 60, 2, LightBevel, DarkBevel, Black);

						XPos = CenterWidth(TheFont2, "Close", 200);
						Draw3D(TheDisplay, TheEditorOKWindow, TheGC,   XPos, 35, "Close", Blue, White, Black);
						XPos = CenterWidth(TheFont2, aboutbuffer1 , EDITORWIDTH);
						XSetForeground(TheDisplay, TheGC, Red);
						XSetFont(TheDisplay, TheGC, TheFont2->fid);
					}
					if ((TheEditorRGBWindow == TheEvent.xany.window) || !FirstTime){

						ClearDigitalField(TheDisplay, TheEditorRGBWindow, TheGC, 11, 32, 95, LightBlack, 3);

						ClearDigitalField(TheDisplay, TheEditorRGBWindow, TheGC, 11, 152, 95, LightBlack, 3);

						ClearDigitalField(TheDisplay, TheEditorRGBWindow, TheGC, 11, 272, 95, LightBlack, 3);

						DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 32, 0, 0,  95, Red, Black, LightBlack
						    + 1000, 3,  customred);
						DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 152, 0, 0,  95, Green, Black, LightBlack
						    + 1000, 3,  customgreen);
						DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 272, 0, 0,  95, Blue, Black, LightBlack
						    + 1000, 3,  customblue);
					}


					if ((TheEditorColorWindow == TheEvent.xany.window) || !FirstTime){
						BevelWindow(TheDisplay, TheEditorColorWindow, TheGC, 1,  0,0, 260, 470, 3, LightBevel, DarkBevel,
						    CustomColor + 1000);
						BevelWindow(TheDisplay, TheEditorColorWindow, TheGC, 0,  5,5, 250, 460, 3, LightBevel, DarkBevel,
						    Black);

						DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 90, 50, 4, 10, Black, Red);
						DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 90, 50, 2, 10, Black, Red);

						DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 240, 50, 4, 10, Black, Green);
						DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 240, 50, 2, 10, Black, Green);

						DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 390, 50, 4, 10, Black, Blue);
						DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 390, 50, 2, 10, Black, Blue);
					}
					if (((TheWindow == TheEvent.xany.window) && ( TheEvent.xexpose.y < 10 + CWINHEIGHT)) || !FirstTime) {
						XSetFont(TheDisplay, TheGC, TheFont->fid);
						XPos = CenterWidth(TheFont, buffer, WIDTH);
						YPos = CenterHeight(TheFont, CWINHEIGHT+10);
						Draw2D(TheDisplay, TheWindow, TheGC,  XPos, YPos, 5, buffer, Red,  Black);
						XPos = CenterWidth(TheFont2, buffer2, WIDTH);
						XSetForeground(TheDisplay, TheGC, Black);
						XSetFont(TheDisplay, TheGC, TheFont2->fid);
						Draw3D(TheDisplay, TheWindow, TheGC,   XPos, HEIGHT - 20, buffer2, SubWindowGrey, White, Black);

						Draw3D(TheDisplay, TheWindow, TheGC,   10, 110, buffer3, SubWindowGrey, Black, White);

						Draw3D(TheDisplay, TheWindow, TheGC,   530, 110, buffer4, SubWindowGrey, Black, White);

					}
					if ((TheWindow == TheEvent.xany.window) || !FirstTime) {
						BevelWindow(TheDisplay, TheWindow, TheGC, 1, /* big */
						0,0, WIDTH, HEIGHT, 5, LightBevel, DarkBevel, Black);
						BevelWindow(TheDisplay, TheWindow, TheGC, 1, /* colors */
						25, 140, WIDTH - CWINWIDTH + 65, HEIGHT - 190 , 1, LightBevel, DarkBevel, WindowGrey );
						BevelWindow(TheDisplay, TheWindow, TheGC, 1, /* "hr" */
						10, 70, WIDTH - 20, 2 , 1, LightBevel, DarkBevel, WindowGrey );
						BevelWindow(TheDisplay, TheWindow, TheGC, 1, /* scroll */
						WIDTH - CWINWIDTH + 100, 140, 101, HEIGHT - 190 , 1, LightBevel, DarkBevel, SuperWindowGrey + 1000);
						BevelWindow(TheDisplay, TheWindow, TheGC, 0, /* scroll2 */
						WIDTH - CWINWIDTH + 100 + 1, 140 + 1, 99, HEIGHT - 190 - 2 , 1, LightBevel, DarkBevel, Black);

					}

					for (i = 0; i <= 5; i++)
						if ((TheButtonWindow[i] == TheEvent.xany.window) ||  !FirstTime) {
							for (x = 0; x <= 3; x++)
								BevelWindow(TheDisplay, TheButtonWindow[x], TheGC, 1,  0, 0,  100, (CWINHEIGHT *
								    2 + 10), 2, LightBevel, DarkBevel,  SuperWindowGrey + 1000);
							for (x = 4; x <= 5; x++)
								BevelWindow(TheDisplay, TheButtonWindow[x], TheGC, 1,  0, 0,  100, (CWINHEIGHT ),
								    2, LightBevel, DarkBevel,  SuperWindowGrey + 1000);
							XPos = CenterWidth(TheFont2, button0, 100);
							YPos = CenterHeight(TheFont2, (CWINHEIGHT * 2 +10));
							Draw3D(TheDisplay, TheButtonWindow[0], TheGC,   XPos, YPos, button0, Red, Black, White);
							XPos = CenterWidth(TheFont2, button1, 100);
							YPos = CenterHeight(TheFont2, (CWINHEIGHT * 2 +10));
							Draw3D(TheDisplay, TheButtonWindow[1], TheGC,   XPos, YPos, button1, Blue, Black, White);
							XPos = CenterWidth(TheFont2, button2, 100);
							YPos = CenterHeight(TheFont2, (CWINHEIGHT * 2 +10));
							YPos -= 15;
							Draw3D(TheDisplay, TheButtonWindow[2], TheGC,   XPos, YPos, button2, Green, Black, White);
							XPos = CenterWidth(TheFont2, button2a, 100);
							YPos += 30;
							Draw3D(TheDisplay, TheButtonWindow[2], TheGC,   XPos, YPos, button2a, Green, Black, White);
							XPos = CenterWidth(TheFont2, button3, 100);
							YPos = CenterHeight(TheFont2, (CWINHEIGHT * 2 +10));
							Draw3D(TheDisplay, TheButtonWindow[3], TheGC,   XPos, YPos, button3, Yellow, Black, White);
							XPos = CenterWidth(TheFont2, button4, 100);
							YPos = CenterHeight(TheFont2, CWINHEIGHT);
							Draw3D(TheDisplay, TheButtonWindow[4], TheGC,   XPos, YPos, button4, Purple, Black, White);


							XPos = CenterWidth(TheFont2, ".", 100) - 7;
							YPos = CenterHeight(TheFont2, (CWINHEIGHT / 2) - 15);
							XSetClipMask(TheDisplay, TheGC, ThePixmapArray[0]);
							XSetClipOrigin(TheDisplay, TheGC, XPos, YPos);
							XSetForeground(TheDisplay, TheGC, Black);
							XCopyPlane(TheDisplay, ThePixmapArray[0],  TheButtonWindow[5], TheGC,  0, 0, 24, 24, XPos,
							    YPos, 1);

							XSetClipMask(TheDisplay, TheGC, NoCow);
							XSetClipOrigin(TheDisplay, TheGC, XPos, YPos);
							XSetForeground(TheDisplay, TheGC, Red);
							XCopyPlane(TheDisplay, NoCow,  TheButtonWindow[5], TheGC,  0, 0, 24, 24, XPos, YPos, 1);

							XSetClipMask(TheDisplay, TheGC, None);
						}
					if ((TheCountWindow[0] == TheEvent.xany.window) || !FirstTime) {
						BevelWindow(TheDisplay, TheCountWindow[0], TheGC, 1, 0,0, 90, CWINHEIGHT, 2, LightBevel, DarkBevel,
						    Black + 1000);

						ClearDigitalField(TheDisplay, TheCountWindow[0], TheGC, 10, 10, 35, LightBlack, 3);

						DigitalPrintRJ (TheDisplay, TheCountWindow[0], TheGC, 10, 10, 100, CWINHEIGHT,  35, Purple, Black,
						    LightBlack + 1000, 3,  percentage);

					}


					if ((TheCountWindow[1] == TheEvent.xany.window) || !FirstTime) {
						BevelWindow(TheDisplay, TheCountWindow[1], TheGC, 1, 0,0, 210, CWINHEIGHT, 2, LightBevel, DarkBevel,
						    Black + 1000);


						ClearDigitalField(TheDisplay, TheCountWindow[1], TheGC, 10, 10, 35, LightBlack, 8);

						DigitalPrintRJ (TheDisplay, TheCountWindow[1], TheGC, 10, 10, 210, CWINHEIGHT, 35, White, Black,
						    LightBlack + 1000, 8, colorcount);

					}

					XSetFont(TheDisplay, TheGC, TheFont2->fid);
					for (x = 0; x <= 9; x++) {
						if ((TheChildWindow[x] == TheEvent.xany.window) || !FirstTime){
							BevelWindow(TheDisplay, TheChildWindow[x], TheGC, 1, 0,0, CWINWIDTH, CWINHEIGHT, 2, LightBevel,
							    DarkBevel, StartColor + x);
							BevelWindow(TheDisplay, TheChildWindow[x], TheGC, 0, 4,4, CWINWIDTH - 8, CWINHEIGHT - 8,
							    2, LightBevel, DarkBevel, StartColor + x + 1000);
							XPos = CenterWidth(TheFont2,  RGBArray[LastIndex + x].ColorName, CWINWIDTH);
							YPos = CenterHeight(TheFont2, CWINHEIGHT);
							Draw3D(TheDisplay, TheChildWindow[x], TheGC,   XPos, YPos, RGBArray[LastIndex + x].ColorName,

							    Black, White, White);

							XFlush(TheDisplay);


						}  /* if */

						if ((TheRGBWindow[x] == TheEvent.xany.window) || !FirstTime){
							BevelWindow(TheDisplay, TheRGBWindow[x], TheGC, 1, 0,0, CWINWIDTH, CWINHEIGHT, 2, LightBevel,
							    DarkBevel, Black + 1000);


							ClearDigitalField(TheDisplay, TheRGBWindow[x], TheGC, 30,10, 35, LightBlack, 3);
							ClearDigitalField(TheDisplay, TheRGBWindow[x], TheGC, 130,10, 35, LightBlack, 3);
							ClearDigitalField(TheDisplay, TheRGBWindow[x], TheGC, 230,10, 35, LightBlack, 3);
							DigitalPrintRJ (TheDisplay, TheRGBWindow[x], TheGC, 30, 10, CWINWIDTH, CWINHEIGHT, 35, Red,
							    Black, LightBlack + 1000, 3, RGBArray[LastIndex + x].Red);
							DigitalPrintRJ (TheDisplay, TheRGBWindow[x], TheGC, 130, 10, CWINWIDTH, CWINHEIGHT, 35, Green,
							    Black, LightBlack + 1000, 3, RGBArray[LastIndex + x].Green);
							DigitalPrintRJ (TheDisplay, TheRGBWindow[x], TheGC, 230, 10, CWINWIDTH, CWINHEIGHT, 35, Blue,
							    Black, LightBlack + 1000, 3, RGBArray[LastIndex + x].Blue);
						}
						if ((TheScrollWindow[x] == TheEvent.xany.window) ||  !FirstTime) {


							BevelWindow(TheDisplay, TheScrollWindow[x], TheGC, 1, 0,0, 90, CWINHEIGHT, 2, LightBevel,
							    DarkBevel, WindowGrey + 1000);

							DrawAllTriangles(TheDisplay, TheScrollWindow, TheGC, x, 6);


						}
					}


					XFlush(TheDisplay);
					if (!FirstTime) {
						FirstTime++;
						colorcount = LoadArray(TheDisplay, TheCountWindow[1], TheGC, TheWindow, TheCursorArray);
						colorcountp = colorcount;
						TheScrollWindowValue[9] = colorcount;
						TheScrollWindowValue[8] = 100;
						TheScrollWindowValue[7] = 50;
						TheScrollWindowValue[6] = 10;
						TheScrollWindowValue[5] = 1;
						TheScrollWindowValue[4] = -1;
						TheScrollWindowValue[3] = -10;
						TheScrollWindowValue[2] = -50;
						TheScrollWindowValue[1] = -100;
						TheScrollWindowValue[0] = -1 * colorcount;
						LastIndex = 0;
						SetColors(TheDisplay, colormap, &RGBArray[LastIndex],  StartColor);
						percentage = (LastIndex + 9) * 100 / colorcountp;
					}
					break;

				case ButtonPress:
					if (TheButtonWindow[0] == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheButtonWindow[0], TheGC, 0,  0, 0,  100, (CWINHEIGHT * 2 + 10), 2, LightBevel,
						    DarkBevel,  SuperWindowGrey );
					}
					if (TheButtonWindow[1] == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheButtonWindow[1], TheGC, 0,  0, 0,  100, (CWINHEIGHT * 2 + 10), 2, LightBevel,
						    DarkBevel,  SuperWindowGrey );
					}
					if (TheButtonWindow[2] == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheButtonWindow[2], TheGC, 0,  0, 0,  100, (CWINHEIGHT * 2 + 10), 2, LightBevel,
						    DarkBevel,  SuperWindowGrey );
					}
					if (TheButtonWindow[3] == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheButtonWindow[3], TheGC, 0,  0, 0,  100, (CWINHEIGHT * 2 + 10), 2, LightBevel,
						    DarkBevel,  SuperWindowGrey );
					}
					if (TheButtonWindow[4] == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheButtonWindow[4], TheGC, 0,  0, 0,  100, (CWINHEIGHT), 2, LightBevel, DarkBevel,

						    SuperWindowGrey );
					}
					if (TheButtonWindow[5] == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheButtonWindow[5], TheGC, 0,  0, 0,  100, (CWINHEIGHT), 2, LightBevel, DarkBevel,

						    SuperWindowGrey );
					}


					for (x = 0; x <= 9; x++)
						if (TheScrollWindow[x] == TheEvent.xbutton.window) {
							BevelWindow(TheDisplay, TheScrollWindow[x], TheGC, 1, 0,0, 90, CWINHEIGHT, 2, LightBevel,
							    DarkBevel, WindowGrey + 1000);


							LastIndex += TheScrollWindowValue[x];

							DrawAllTriangles(TheDisplay, TheScrollWindow, TheGC, x, 0);



							if (LastIndex > EndOfArray - 10) {
								LastIndex = EndOfArray - 10;
								percentage = 100;
							}
							else if (LastIndex < 0) {
								LastIndex = 0;
								percentage = (LastIndex + 9) * 100 / colorcountp;
							}
							else
								percentage = (LastIndex + 9) * 100 / colorcountp;

							SetColors(TheDisplay, colormap, &RGBArray[LastIndex], StartColor);

							for (x = LastIndex; x <= (LastIndex + 9); x++) {


								DrawNewStuff(TheDisplay, TheChildWindow[x - LastIndex],  0, 0, CWINWIDTH, CWINHEIGHT);

								DrawNewStuff(TheDisplay, TheRGBWindow[x - LastIndex],  0, 0, CWINWIDTH, CWINHEIGHT);

								DigitalPrintRJ (TheDisplay, TheCountWindow[0], TheGC, 10, 10, 100, CWINHEIGHT,  35,
								    Purple, Black, LightBlack + 1000, 3,  percentage);
							} /* for */
						} /* if TheScrollWindow */

					if (TheAboutMailWindow == TheEvent.xbutton.window)
						BevelWindow(TheDisplay, TheAboutMailWindow, TheGC, 0, 0,0, 200, 60, 2, LightBevel, DarkBevel, White);

					if (TheAboutOKWindow == TheEvent.xbutton.window)
						BevelWindow(TheDisplay, TheAboutOKWindow, TheGC, 0, 0,0, 200, 60, 2, LightBevel, DarkBevel, White);

					if (TheEditorOKWindow == TheEvent.xbutton.window)
						BevelWindow(TheDisplay, TheEditorOKWindow, TheGC, 0, 0,0, 200, 60, 2, LightBevel, DarkBevel, White);

					if (TheEditorColorWindow == TheEvent.xbutton.window) {
						triangle = WhichTriangle(TheEvent.xbutton.x, TheEvent.xbutton.y);

						XSetForeground(TheDisplay, TheGC, CustomColor);

						if (triangle == 1) {
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 63, 25, 60, 120 );
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 90, 50, 4, 0, Black, Red);
						}
						else if (triangle == 2) {
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 63, 175, 60, 120 );
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 240, 50, 4, 0, Black, Green);
						}
						else if (triangle == 3) {
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 63, 325, 60, 120 );
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 390, 50, 4, 0, Black, Blue);
						}
						else if (triangle == 4) {
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 143, 25, 60, 120 );
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 90, 50, 2, 0, Black, Red);
						}
						else if (triangle == 5) {
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 143, 175, 60, 120 );
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 240, 50, 2, 0, Black, Green);
						}
						else if (triangle == 6) {
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 143, 325, 60, 120 );
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 390, 50, 2, 0, Black, Blue);
						}
					}
					XFlush(TheDisplay);
					usleep(100000);
					break;

				case ButtonRelease:
					for (x = 0; x <= 5; x++)
						if (TheButtonWindow[x] == TheEvent.xbutton.window) {
							if (!x) {
								BevelWindow(TheDisplay, TheButtonWindow[0], TheGC, 1, 0, 0, 100, (CWINHEIGHT * 2
								    + 10), 2, LightBevel, DarkBevel, SuperWindowGrey );
								XDestroyWindow(TheDisplay, TheWindow);
								XCloseDisplay(TheDisplay);
								exit(0);
							}
							if (x == 1) {
								BevelWindow(TheDisplay, TheButtonWindow[1], TheGC, 1,  0, 0,  100, (CWINHEIGHT *
								    2 + 10), 2, LightBevel, DarkBevel,  SuperWindowGrey );
								FirstTime = 0;
								LastIndex = 0;
								colorcount = 0;
								percentage = 0;
								DrawNewStuff(TheDisplay, TheButtonWindow[x],  0, 0, CWINWIDTH, CWINHEIGHT);
								ClearDigitalField(TheDisplay, TheCountWindow[1], TheGC, 10, 10, 35, LightBlack, 8);

							}

							if (x == 2) {
								BevelWindow(TheDisplay, TheButtonWindow[2], TheGC, 1,  0, 0,  100, (CWINHEIGHT *
								    2 + 10), 2, LightBevel, DarkBevel,  SuperWindowGrey );
								XMapRaised(TheDisplay, TheEditorWindow);
								XMapSubwindows(TheDisplay, TheEditorWindow);
							}
							if (x == 3) {
								char browserbuffer[100] = BROWSERPATH;
								BevelWindow(TheDisplay, TheButtonWindow[3], TheGC, 1,  0, 0,  100, (CWINHEIGHT *
								    2 + 10), 2, LightBevel, DarkBevel,  SuperWindowGrey );
                                                                strcat(browserbuffer, INSTALLDIR);
								strcat(browserbuffer, "/XCOLORSEL/HTMLHELP/XColorSel.html & ");
								system(browserbuffer);

							}
							if (x == 4) {
								BevelWindow(TheDisplay, TheButtonWindow[4], TheGC, 1,  0, 0,  100, (CWINHEIGHT),
								    2, LightBevel, DarkBevel,  SuperWindowGrey );
								XMapRaised(TheDisplay, TheAboutWindow);
								XMapSubwindows(TheDisplay, TheAboutWindow);
							}
							if (x == 5) {
								BevelWindow(TheDisplay, TheButtonWindow[5], TheGC, 1,  0, 0,  100, (CWINHEIGHT),
								    2, LightBevel, DarkBevel,  SuperWindowGrey + 1000);

								XPos = CenterWidth(TheFont2, ".", 100) - 7;
								YPos = CenterHeight(TheFont2, (CWINHEIGHT / 2) - 15);
								XSetClipMask(TheDisplay, TheGC, ThePixmapArray[0]);
								XSetClipOrigin(TheDisplay, TheGC, XPos, YPos);
								XSetForeground(TheDisplay, TheGC, Black);
								XCopyPlane(TheDisplay, ThePixmapArray[0], TheButtonWindow[5], TheGC, 0, 0, 24, 24,
								    XPos, YPos, 1);
								if (cowcursorbool) {
									TheCurrentCursor = DefaultCursor;
									cowcursorbool = 0;
								}
								else {
									TheCurrentCursor = TheCursorArray[0];
									cowcursorbool = 1;
									XSetClipMask(TheDisplay, TheGC, NoCow);
									XSetClipOrigin(TheDisplay, TheGC, XPos, YPos);
									XSetForeground(TheDisplay, TheGC, Red);
									XCopyPlane(TheDisplay, NoCow, TheButtonWindow[5], TheGC, 0, 0, 24, 24, XPos,
									    YPos, 1);
								}
								XSetClipMask(TheDisplay, TheGC, None);
								XDefineCursor(TheDisplay, TheWindow,  TheCurrentCursor);
								XDefineCursor(TheDisplay, TheAboutWindow,  TheCurrentCursor);
								XDefineCursor(TheDisplay, TheEditorWindow,  TheCurrentCursor);
							}
						}

					for (x = 0; x <= 9; x++) {
						if (TheScrollWindow[x] == TheEvent.xbutton.window) {
							BevelWindow(TheDisplay, TheScrollWindow[x], TheGC, 1, 0,0, 90, CWINHEIGHT, 2, LightBevel,
							    DarkBevel, WindowGrey + 1000);

							DrawAllTriangles(TheDisplay, TheScrollWindow, TheGC, x, 6);
						}
						else if (TheChildWindow[x] == TheEvent.xbutton.window) {
							customred = RGBArray[LastIndex + x].Red;
							customgreen = RGBArray[LastIndex + x].Green;
							customblue = RGBArray[LastIndex + x].Blue;

							color.pixel = CustomColor;
							color.red = ColorAdjust(customred);
							color.green = ColorAdjust(customgreen);
							color.blue = ColorAdjust(customblue);
							XStoreColor(TheDisplay, colormap, &color);

							XMapRaised(TheDisplay, TheEditorWindow);
							XMapSubwindows(TheDisplay, TheEditorWindow);

						} /* if */
					} /* for */

					if (TheAboutMailWindow == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheAboutMailWindow, TheGC, 1, 0,0, 200, 60, 2, LightBevel, DarkBevel, White);
						system("xterm -T \"^D or 'CR.' sends, ^C aborts\"" " -e mail -s \"XColorSel Comments\" " "stei0302@cs.fredonia.edu &");
					}

					if (TheAboutOKWindow == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheAboutOKWindow, TheGC, 1, 0,0, 200, 60, 2, LightBevel, DarkBevel, White);
						XUnmapWindow(TheDisplay, TheAboutWindow);
					}
					if (TheEditorOKWindow == TheEvent.xbutton.window) {
						BevelWindow(TheDisplay, TheEditorOKWindow, TheGC, 1, 0,0, 200, 60, 2, LightBevel, DarkBevel, White);
						XUnmapWindow(TheDisplay, TheEditorWindow);
					}

					if (TheEditorColorWindow == TheEvent.xbutton.window) {
						int flag = 0;

						XSetForeground(TheDisplay, TheGC, CustomColor);

						if (triangle == 1) {
							flag++;
							if (customred)
								customred--;
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 63, 25, 60, 120 );
							DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 32, 0, 0,  95, Red, Black, LightBlack
							    + 1000, 3,  customred);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 90, 50, 4, 10, Black, Red);
							XFlush(TheDisplay);
						}
						else if (triangle == 2) {
							flag++;
							if (customgreen)
								customgreen--;
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 63, 175, 60, 120 );
							DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 152, 0, 0,  95, Green, Black,
							    LightBlack + 1000, 3,  customgreen);
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 240, 50, 4, 10, Black, Green);
						}
						else if (triangle == 3) {
							flag++;
							if (customblue)
								customblue--;
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 63, 325, 60, 120 );
							DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 272, 0, 0,  95, Blue, Black, LightBlack
							    + 1000, 3,  customblue);
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 390, 50, 4, 10, Black, Blue);
						}
						else if (triangle == 4) {
							flag++;
							if (customred < 255)
								customred++;
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 143, 25, 60, 120 );
							DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 32, 0, 0,  95, Red, Black, LightBlack
							    + 1000, 3,  customred);
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 90, 50, 2, 10, Black, Red);
						}
						else if (triangle == 5) {
							flag++;
							if (customgreen < 255)
								customgreen++;
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 143, 175, 60, 120 );
							DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 152, 0, 0,  95, Green, Black,
							    LightBlack + 1000, 3,  customgreen);
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 240, 50, 2, 10, Black, Green);
						}
						else if (triangle == 6) {
							flag++;
							if (customblue < 255)
								customblue++;
							XFillRectangle(TheDisplay, TheEditorColorWindow,  TheGC, 143, 325, 60, 120 );
							DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 272, 0, 0,  95, Blue, Black, LightBlack
							    + 1000, 3,  customblue);
							XFlush(TheDisplay);
							DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 390, 50, 2, 10, Black, Blue);
						}
						if (flag) {
							color.pixel = CustomColor;
							color.red = ColorAdjust(customred);
							color.green = ColorAdjust(customgreen);
							color.blue = ColorAdjust(customblue);
							XStoreColor(TheDisplay, colormap, &color);
						}
						triangle = 0;

					}


					XFlush(TheDisplay);
					break;
				} /* switch */
			} /* while (XCheckMaskEvent) */
		} /* select if */
		else {
			int flag = 0;
			XSetForeground(TheDisplay, TheGC, CustomColor);

			if (triangle == 1) {
				flag++;
				if (customred)
					customred--;
				DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 32, 0, 0,  95, Red, Black, LightBlack + 1000, 3,  customred);
				DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 90, 50, 4, 0, Black, Red);
				XFlush(TheDisplay);
			}
			else if (triangle == 2) {
				flag++;
				if (customgreen)
					customgreen--;
				DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 152, 0, 0,  95, Green, Black, LightBlack + 1000, 3,  customgreen);
				XFlush(TheDisplay);
				DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 240, 50, 4, 0, Black, Green);
			}
			else if (triangle == 3) {
				flag++;
				if (customblue)
					customblue--;
				DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 272, 0, 0,  95, Blue, Black, LightBlack + 1000, 3,  customblue);
				XFlush(TheDisplay);
				DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 95, 390, 50, 4, 0, Black, Blue);
			}
			else if (triangle == 4) {
				flag++;
				if (customred < 255)
					customred++;
				DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 32, 0, 0,  95, Red, Black, LightBlack + 1000, 3,  customred);
				XFlush(TheDisplay);
				DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 90, 50, 2, 0, Black, Red);
			}
			else if (triangle == 5) {
				flag++;
				if (customgreen < 255)
					customgreen++;
				DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 152, 0, 0,  95, Green, Black, LightBlack + 1000, 3,  customgreen);
				XFlush(TheDisplay);
				DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 240, 50, 2, 0, Black, Green);
			}
			else if (triangle == 6) {
				flag++;
				if (customblue < 255)
					customblue++;
				DigitalPrintRJ (TheDisplay, TheEditorRGBWindow, TheGC, 11, 272, 0, 0,  95, Blue, Black, LightBlack + 1000, 3,  customblue);
				XFlush(TheDisplay);
				DrawTriangle(TheDisplay, TheEditorColorWindow, TheGC, 175, 390, 50, 2, 0, Black, Blue);
			}
			if (flag) {
				color.pixel = CustomColor;
				color.red = ColorAdjust(customred);
				color.green = ColorAdjust(customgreen);
				color.blue = ColorAdjust(customblue);
				XStoreColor(TheDisplay, colormap, &color);
			}
		}
	} /* while */



}  /* end of main */


/******************************************************************************
FUNCTION: DrawAllTriangles;  Is a cheesy function to save a lot of space.
******************************************************************************/
void DrawAllTriangles(Display *TheDisplay, Window TheScrollWindow[] , GC TheGC, 
int x, int h)
{
	if (!x) {
		DrawTriangle(TheDisplay, TheScrollWindow[0], TheGC,  45, CWINHEIGHT / 2 - 7, /* x, y */
		20,   /* size */
		1, /* direction */
		h, /* height */
		Black, Yellow);

		DrawTriangle(TheDisplay, TheScrollWindow[0], TheGC,  45, CWINHEIGHT / 2 + 7, /* x, y */
		20,   /* size */
		1, /* direction */
		h, /* height */
		Black, Yellow);
	} /* if 0  */

	else if (x == 1)
		DrawTriangle(TheDisplay, TheScrollWindow[1], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		25,   /* size */
		1, /* direction */
		h, /* height */
		Black, Yellow);



	else if (x == 2)
		DrawTriangle(TheDisplay, TheScrollWindow[2], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		20,   /* size */
		1, /* direction */
		h, /* height */
		Black, Yellow);


	else if (x == 3)
		DrawTriangle(TheDisplay, TheScrollWindow[3], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		15,   /* size */
		1, /* direction */
		h, /* height */
		Black, Yellow);
	else if (x == 4)
		DrawTriangle(TheDisplay, TheScrollWindow[4], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		10,   /* size */
		1, /* direction */
		h, /* height */
		Black, Yellow);

	else if (x == 8)
		DrawTriangle(TheDisplay, TheScrollWindow[8], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		25,   /* size */
		3, /* direction */
		h, /* height */
		Black, Yellow);

	else if (x == 7)
		DrawTriangle(TheDisplay, TheScrollWindow[7], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		20,   /* size */
		3, /* direction */
		h, /* height */
		Black, Yellow);

	else if (x == 6)
		DrawTriangle(TheDisplay, TheScrollWindow[6], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		15,   /* size */
		3, /* direction */
		h, /* height */
		Black, Yellow);

	else if (x == 5)
		DrawTriangle(TheDisplay, TheScrollWindow[5], TheGC,  45, CWINHEIGHT / 2, /* x, y */
		10,   /* size */
		3, /* direction */
		h, /* height */
		Black, Yellow);

	else if (x == 9) {
		DrawTriangle(TheDisplay, TheScrollWindow[9], TheGC,  45, CWINHEIGHT / 2 - 7, /* x, y */
		20,   /* size */
		3, /* direction */
		h, /* height */
		Black, Yellow);


		DrawTriangle(TheDisplay, TheScrollWindow[9], TheGC,  45, CWINHEIGHT / 2 + 7, /* x, y */
		20,   /* size */
		3, /* direction */
		h, /* height */
		Black, Yellow);

	}  /* else if 9 */
}



/******************************************************************************
FUNCTION: LoadArray; Loads up the color array.
******************************************************************************/
int LoadArray(Display *TheDisplay, Window TheCountWindow, GC TheGC,
Window TheWindow, Cursor *TheCursorArray)
{
	FILE *fh1;
	char tempbuffer[100], stringbuffer[50];
	int RedInt, GreenInt, BlueInt, cursorpos = 0;

	if( !(fh1 = fopen(RGBTXTPATH, "r"))) {
		printf("XColorSel: Could not find %s\n", RGBTXTPATH);
		exit(10);
	}

	if (!(RGBArray = (struct RGBtxt *) malloc(CHUNK * sizeof(struct RGBtxt)))) {
		puts("XColorSel: Not enough memory... Program execution halted!!");
		exit(10);
	}
	EndOfArray = CHUNK - 1;

	for (LastIndex = 0; fgets(tempbuffer, 100, fh1); LastIndex++) {
		while (tempbuffer[0] == '!')
			fgets(tempbuffer, 100, fh1);

		if (!(LastIndex % 20)) {
			cursorpos = CursorSpin(TheDisplay, TheWindow, TheCursorArray,  cursorpos, 0);
			if (cursorpos < 0)
				cursorpos = NUMCURSORS - 1;
			else
				cursorpos %= NUMCURSORS;
		}

		DigitalPrintRJ (TheDisplay, TheCountWindow, TheGC, 10, 10, 210, CWINHEIGHT, 35, White, Black, LightBlack + 1000, 8, LastIndex + 1);
		XFlush(TheDisplay);

		sscanf(tempbuffer, "%d %d %d %[a-zA-Z0-9_ ]", &RedInt, &GreenInt,  &BlueInt, stringbuffer);
		RGBArray[LastIndex].Red = RedInt;
		RGBArray[LastIndex].Green = GreenInt;
		RGBArray[LastIndex].Blue = BlueInt;
		RGBArray[LastIndex].ColorName =  (char *) malloc(strlen(stringbuffer)+1);
		strcpy(RGBArray[LastIndex].ColorName, stringbuffer);


		if (LastIndex == EndOfArray) {
			if (!(RGBArray = (struct RGBtxt *) realloc(RGBArray,  ((LastIndex + 10 + CHUNK) * sizeof(struct RGBtxt))))) {
				puts("XColorSel: Not enough memory to continue... " " Program execution halted!!");
				exit(10);
			}
			EndOfArray += CHUNK;
		}
	}
	XDefineCursor(TheDisplay, TheWindow, TheCurrentCursor);
	EndOfArray = LastIndex - 1;
	return LastIndex;

}


/******************************************************************************
FUNCTION: SetColors; Sets the 10 colors to be used next
******************************************************************************/
void SetColors(Display *TheDisplay, Colormap colormap, struct RGBtxt *RGBArray, unsigned long StartColor)
{
	int x;
	XColor color;

	color.flags = DoRed | DoGreen | DoBlue;

	for (x = StartColor; (x < StartColor + 10) && (x <= EndOfArray) ; x++) {
		color.pixel = x;
		color.red =  ColorAdjust(RGBArray->Red);
		color.green =  ColorAdjust(RGBArray->Green);
		color.blue =  ColorAdjust(RGBArray->Blue);
		XStoreColor(TheDisplay, colormap, &color);
		RGBArray++;
	}
}

/******************************************************************************
FUNCTION: DrawNewStuff;  sends XEvent to redraw stuff.
******************************************************************************/
void DrawNewStuff(Display *TheDisplay, Window TheWindow, int X, int Y, 
int Width, int Height)
{

	XEvent EventVar;

	EventVar.xexpose.type = Expose;
	EventVar.xexpose.display = TheDisplay;
	EventVar.xexpose.window = TheWindow;
	EventVar.xexpose.x = X;
	EventVar.xexpose.y = Y;
	EventVar.xexpose.width = Width;
	EventVar.xexpose.height = Height;

	XSendEvent (TheDisplay, TheWindow, 1, ExposureMask, &EventVar);
}


/******************************************************************************
FUNCTION: WhichTriangle;
******************************************************************************/
int WhichTriangle(int x, int y) {

	if ((x >= 50) && (x <= 100) && (y >= 20) && (y <= 115))
		return 1;
	else if ((x >= 50) && (x <= 100) && (y >= 170) && (y <= 275))
		return 2;
	else if ((x >= 50) && (x <= 100) && (y >= 320) && (y <= 415))
		return 3;
	if ((x >= 138) && (x <= 183) && (y >= 20) && (y <= 115))
		return 4;
	else if ((x >= 138) && (x <= 183) && (y >= 170) && (y <= 275))
		return 5;
	else if ((x >= 138) && (x <= 183) && (y >= 320) && (y <= 415))
		return 6;
}
/******************************************************************************
FUNCTION: WhichTriangle;
******************************************************************************/
int XtoY(int x, int y) 
{
    if (!x) return 0;
    if (!y) return 1;
    return x * XtoY(x, y-1);
}
